[pacman-dev] [PATCH] Bazaar VCS support
Gary van der Merwe
garyvdm at gmail.com
Mon Sep 10 10:24:33 EDT 2012
I'm really sorry about the delay replying to this. Some how, I did not
see your reply till today.
On Thu 16 Aug 2012 05:38:55 SAST, Allan McRae wrote:
> All the current VCS use the format url#<what>=<value>. From your
> patch, it seems that bzr has only one thing for "<what>", but we should
> stick to that syntax anyway - much like SVN that only supports revision.
>
> Maybe I should make the fragment syntax clearer in the man page.
>
> Anyway, reading document for bzr, would using:
>
> url#revision=revno:3:/path/to/branch
>
> be suitable? From what I can see "revision" is used to describe the
> parameter "e.g. --revision in bzr branch", so that should hopefully not
> be too confusing (and all confusion might be due to my lack of bzr
> knowledge).
Ok, After reading PKGBUILD.5.txt again, I see the inconsistency. I've
updated the patch so that the revisionspec fragment would be specified
like this, so that is consistent with the others:
url#revision=[any bzr revisionspec]
url#revision=3
url#revision=tag:mytag
>> + if [[ ! -d "$dir" ]]; then
>
> Add check if directory is there but empty - recent patch by Mohammad
> Alsaleh for git on this list.
Done.
>> + msg2 "$(gettext "Branching %s ...")" "${displaylocation}"
>> + if ! bzr branch "$url" "$dir" $revisionspec --no-tree; then
>
> All other VCS functions do a full checkout here and do the checkout of
> the revision when creating the working branch. With that, you can get
> rid of the $displaylocation variable.
That would not work for Bazaar. This is why:
Unlike git/hg, bzr urls refer to a branch, not a repo.
When you do a bzr branch/pull, it only fetches revisions that are descendants of the branch tip into the local repo. Hence, doing a branch/pull without specifying the fragment revision, it is possible that the fragment revision is not available. Here is an example revision dag for which this would happen:
fragment revision = tag:mytag
c (branch tip
| b (tag:mytag
|/
a
>> + elif (( ! HOLDVER )); then
>> + msg2 "$(gettext "Pulling %s ...")" "${displaylocation}"
>> + cd_safe "$dir"
>
> is it possible to check that the contents of this directory are a bzr
> repo from the given url?
Done.
Signed-off-by: Gary van der Merwe <garyvdm at gmail.com>
---
doc/PKGBUILD.5.txt | 5 +++-
scripts/makepkg.sh.in | 77 +++++++++++++++++++++++++++++++++++++++++++++++++--
2 files changed, 78 insertions(+), 4 deletions(-)
diff --git a/doc/PKGBUILD.5.txt b/doc/PKGBUILD.5.txt
index 47f9e88..052c2eb 100644
--- a/doc/PKGBUILD.5.txt
+++ b/doc/PKGBUILD.5.txt
@@ -405,7 +405,7 @@ Using VCS Sources[[VCS]]
------------------------
Building a developmental version of a package using sources from a version control
system (VCS) is enabled by specifying the source in the form
-`source=('folder::url#fragment')`. Currently makepkg supports the `git`, `hg` and
+`source=('folder::url#fragment')`. Currently makepkg supports the `git`, `hg`, `bzr` and
`svn` protocols.
The source URL is divided into three components:
@@ -433,6 +433,9 @@ The source URL is divided into three components:
*hg*;;
branch, revision, tag
+ *bzr*;;
+ revision (see `bzr help revisionspec` for details)
+
*svn*;;
revision
diff --git a/scripts/makepkg.sh.in b/scripts/makepkg.sh.in
index 6de7b4f..ca99566 100644
--- a/scripts/makepkg.sh.in
+++ b/scripts/makepkg.sh.in
@@ -200,7 +200,7 @@ get_filepath() {
local proto="$(get_protocol "$1")"
case $proto in
- git*|hg*|svn*)
+ git*|hg*|svn*|bzr*)
if [[ -d "$startdir/$file" ]]; then
file="$startdir/$file"
elif [[ -d "$SRCDEST/$file" ]]; then
@@ -236,7 +236,7 @@ get_filename() {
local proto=$(get_protocol "$netfile")
case $proto in
- git*|hg*|svn*)
+ git*|hg*|svn*|bzr*)
filename=${netfile%%#*}
filename=${filename%/}
filename=${filename##*/}
@@ -578,6 +578,74 @@ download_svn() {
popd &>/dev/null
}
+download_bzr() {
+ local netfile=$1
+
+ local url=$(get_url "$netfile")
+ url=${url##*bzr+}
+ url=${url%%#*}
+
+ local fragment=${netfile##*#}
+ if [[ $fragment = "$netfile" ]]; then
+ unset fragment
+ fi
+
+ local displaylocation="$url"
+ local revision="-r-1"
+
+ if [[ -n $fragment ]]; then
+ case ${fragment%%=*} in
+ revision)
+ revision="-r${fragment##*=}"
+ displaylocation="$url -r ${fragment##*=}"
+ ;;
+ *)
+ error "$(gettext "Unrecognized reference: %s")" "${fragment}"
+ plain "$(gettext "Aborting...")"
+ exit 1
+ esac
+ fi
+
+ local dir=$(get_filepath "$netfile")
+ [[ -z "$dir" ]] && dir="$SRCDEST/$(get_filename "$netfile")"
+
+ if [[ ! -d "$dir" ]] || dir_is_empty "$dir" ; then
+ msg2 "$(gettext "Branching %s ...")" "${displaylocation}"
+ if ! bzr branch "$url" "$dir" $revisionspec --no-tree --use-existing-dir; then
+ error "$(gettext "Failure while branching %s")" "${displaylocation}"
+ plain "$(gettext "Aborting...")"
+ exit 1
+ fi
+ elif (( ! HOLDVER )); then
+ # Make sure we are fetching the right repo
+ if [[ "$url" != "$(bzr config parent_location -d $dir)" ]] ; then
+ error "$(gettext "%s is not a branch of %s")" "$dir" "$url"
+ plain "$(gettext "Aborting...")"
+ exit 1
+ fi
+ msg2 "$(gettext "Pulling %s ...")" "${displaylocation}"
+ cd_safe "$dir"
+ if ! bzr pull "$url" $revisionspec --overwrite; then
+ # only warn on failure to allow offline builds
+ warning "$(gettext "Failure while pulling %s")" "${displaylocation}"
+ fi
+ fi
+
+ msg2 "$(gettext "Creating working copy of %s %s repo...")" "${dir}" "bzr"
+ pushd "$srcdir" &>/dev/null
+ rm -rf "${dir##*/}"
+
+ if ! bzr checkout "$dir" --lightweight; then
+ error "$(gettext "Failure while creating working copy of %s %s repo")" "${dir}" "bzr"
+ plain "$(gettext "Aborting...")"
+ exit 1
+ fi
+
+ cd_safe "${dir##*/}"
+
+ popd &>/dev/null
+}
+
download_sources() {
msg "$(gettext "Retrieving Sources...")"
@@ -605,6 +673,9 @@ download_sources() {
svn*)
(( GET_VCS )) && download_svn "$netfile"
;;
+ bzr*)
+ (( GET_VCS )) && download_bzr "$netfile"
+ ;;
*)
download_file "$netfile"
;;
@@ -975,7 +1046,7 @@ generate_checksums() {
proto="$(get_protocol "$netfile")"
case $proto in
- git*|hg*|svn*)
+ git*|hg*|svn*|bzr*)
sum="SKIP"
;;
*)
--
1.7.12
More information about the pacman-dev
mailing list